; mini.asm
; 31 bites digitlis zajgenertor, rvid vltozat
; Msfeledik kisrletem AVR processzorral. 
; Kimenetei: 
; 1 kHz szimmetrikus ngyszgjel a 7-es lbon (tesztkimenet)
; digitlis zaj az 5-s lbon (tesztkimenet)
; ha a 4-es lb 0, akkor modullt zaj,
; ha 1, akkor csak zaj a 2-es lbon (tnyleges kimenet)
; rvidtett vltozat
.nolist
.INCLUDE "tn212def.inc"; 
.list
.DEF TEMPDATA=r18; r18-at hasznlom konstansok clba juttatsra 

start:
    ldi TEMPDATA,0x4c; 
	sts VPORTA_DIR,TEMPDATA; PA2, 3, 6 kimenet lesz
	ldi TEMPDATA,8;
	sts PORTA_PIN1CTRL,TEMPDATA; bels felhz a 4-es lbon (PA1, jumper be)
	sts PORTA_PIN7CTRL,TEMPDATA; bels felhz a 3-as lbon (PA7, lgna)
	ldi TEMPDATA,2;
	sts FUSE_OSCCFG,TEMPDATA; 20 MHz alapra (a default is ez)	
	ldi TEMPDATA,0xd8;
	sts CPU_CCP,TEMPDATA; kulcs
	ldi TEMPDATA,0;
	sts CLKCTRL_MCLKCTRLA,TEMPDATA; a default is ez (20 MHz, no CLKOUT)
	ldi TEMPDATA,0xd8;
	sts CPU_CCP,TEMPDATA; kulcs
	ldi TEMPDATA,0;
	sts CLKCTRL_MCLKCTRLB,TEMPDATA; nincs frekvenciaoszts (itt ktelez)
	ldi TEMPDATA,LOW (9999);
	sts TCA0_SINGLE_CMP0,TEMPDATA;
	ldi TEMPDATA,HIGH (9999);
	sts TCA0_SINGLE_CMP0+1,TEMPDATA; TCA0.CMP0=9999 (1 kHz lesz belle)
	ldi TEMPDATA,0x11;
	sts TCA0_SINGLE_CTRLB,TEMPDATA; frekvencia md CMP0 hasznlatval 
	ldi TEMPDATA,1;
	sts TCA0_SINGLE_CTRLA,TEMPDATA; engedlyezve (az 1 kHz 7-es lbon)
	ldi TEMPDATA,0x5a; 
	mov r3,TEMPDATA; kezd bitminta a lptetregiszter egyik tagjnak
; ez a rszlet felel a modullt kimenetrt:
	ldi TEMPDATA,0x58;
	sts CCL_LUT0CTRLB,TEMPDATA; LUT0_IN1 s TCA0_WO0 (4-es s 7-es lb)
	ldi TEMPDATA,0x5;
	sts CCL_LUT0CTRLC,TEMPDATA; LUT0_IN2 (PA2 zajkimenet, 5-s lb)
	ldi TEMPDATA,0xE0;
	sts CCL_TRUTH0,TEMPDATA; LUT0 igazsgtblja 
	ldi TEMPDATA,0x9;
	sts CCL_LUT0CTRLA,TEMPDATA; LUT0 s kimenete a 2-es lbon engedlyezve
	ldi TEMPDATA,1;
	sts CCL_CTRLA,TEMPDATA; CCL0 engedlyezve, most mr mkdhet

	ldi r31,1; Z regiszter fels bjt, csak a nyjtottakhoz kell. 

;  31 bites lvletlen genertor hurok
loop:
	clc; ez a ngy utasts vlasztja ki s invertlja a visszacsatol bitet
	andi r16,4;	r16.2 marad meg
	brbc 1,sk1; ugorj, ha nem nulla
	sec; 
sk1:
	rol r1; r16.2 inverze lp be a C biten keresztl
	rol r2; 
	rol r3; 
	rol r4; mind a ngy bjt lp, tvitellel
	mov r30,r4; Z aljaknti felhasznls eltt mg mdosul, 
	ror r30; mert a visszacsatols szmtsban is rszt vesz
	mov r16,r4; a visszacsatols szmtshoz kell
	swap r16; 
	out VPORTA_OUT,r4; br az egszet kiteszem, csak az 5-s lbon rvnyesl
	eor r16,r30; itt ll el a visszacsatol bit r16.2-n
	rjmp loop;

